/**
 * kalu - Copyright (C) 2012 Olivier Brunel
 *
 * updater-dbus.h
 * Copyright (C) 2012 Olivier Brunel <i.am.jack.mail@gmail.com>
 * 
 * This file is part of kalu.
 *
 * kalu is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * kalu is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * kalu. If not, see http://www.gnu.org/licenses/
 */

#ifndef _KALU_UPDATER_DBUS_H
#define _KALU_UPDATER_DBUS_H

#include "kupdater.h"

#define DBUS_NAME               "org.jjk.kalu"
#define OBJECT_PATH             "/org/jjk/kalu/Updater"
#define INTERFACE_NAME          "org.jjk.kalu.UpdaterInterface"

/* Introspection data for the service we are exporting */
static const gchar introspection_xml[] =
  "<node>"
  "  <interface name='org.jjk.kalu.UpdaterInterface'>"
  "    <method name='Init'>"
  "    </method>"
  "    <method name='InitAlpm'>"
  "      <arg type='s'  name='rootdir'      direction='in'/>"
  "      <arg type='s'  name='dbpath'       direction='in'/>"
  "      <arg type='s'  name='logfile'      direction='in'/>"
  "      <arg type='s'  name='gpgdir'       direction='in'/>"
  "      <arg type='as' name='cachedirs'    direction='in'/>"
  "      <arg type='i'  name='siglevel'     direction='in'/>"
  "      <arg type='s'  name='arch'         direction='in'/>"
  "      <arg type='b'  name='checkspace'   direction='in'/>"
  "      <arg type='b'  name='usesyslog'    direction='in'/>"
  "      <arg type='b'  name='usedelta'     direction='in'/>"
  "      <arg type='as' name='ignorepkgs'   direction='in'/>"
  "      <arg type='as' name='ignoregroups' direction='in'/>"
  "      <arg type='as' name='noupgrades'   direction='in'/>"
  "      <arg type='as' name='noextracts'   direction='in'/>"
  "    </method>"
  "    <method name='AddDb'>"
  "      <arg type='s'  name='name'         direction='in'/>"
  "      <arg type='i'  name='siglevel'     direction='in'/>"
  "      <arg type='as' name='servers'      direction='in'/>"
  "    </method>"
  "    <method name='SyncDbs'>"
  "    </method>"
  "    <method name='Answer'>"
  "      <arg type='i'  name='choice'      direction='in'/>"
  "    </method>"
  "    <method name='GetPackages'>"
  "    </method>"
  "    <method name='SysUpgrade'>"
  "    </method>"
  "    <method name='NoSysUpgrade'>"
  "    </method>"
  "    <method name='FreeAlpm'>"
  "    </method>"
  "    <signal name='MethodFailed'>"
  "      <arg type='s' name='name' />"
  "      <arg type='s' name='msg' />"
  "    </signal>"
  "    <signal name='MethodFinished'>"
  "      <arg type='s' name='name' />"
  "    </signal>"
  "    <signal name='GetPackagesFinished'>"
  "      <arg type='a(sssuuu)' name='pkgs' />"
  "    </signal>"
  "    <signal name='Downloading'>"
  "      <arg type='s' name='filename' />"
  "      <arg type='u' name='transfered' />"
  "      <arg type='u' name='total' />"
  "    </signal>"
  "    <signal name='SyncDbs'>"
  "      <arg type='i' name='nb' />"
  "    </signal>"
  "    <signal name='SyncDbStart'>"
  "      <arg type='s' name='name' />"
  "    </signal>"
  "    <signal name='SyncDbEnd'>"
  "      <arg type='i' name='result' />"
  "    </signal>"
  "    <signal name='Log'>"
  "      <arg type='i' name='level' />"
  "      <arg type='s' name='msg' />"
  "    </signal>"
  "    <signal name='AskInstallIgnorePkg'>"
  "      <arg type='s' name='pkg' />"
  "    </signal>"
  "    <signal name='AskReplacePkg'>"
  "      <arg type='s' name='repo1' />"
  "      <arg type='s' name='pkg1' />"
  "      <arg type='s' name='repo2' />"
  "      <arg type='s' name='pkg2' />"
  "    </signal>"
  "    <signal name='AskConflictPkg'>"
  "      <arg type='s' name='pkg1' />"
  "      <arg type='s' name='pkg2' />"
  "      <arg type='s' name='reason' />"
  "    </signal>"
  "    <signal name='AskRemovePkgs'>"
  "      <arg type='as' name='pkgs' />"
  "    </signal>"
  "    <signal name='AskSelectProvider'>"
  "      <arg type='s'   name='pkg' />"
  "      <arg type='aas' name='providers' />"
  "    </signal>"
  "    <signal name='AskLocalNewer'>"
  "      <arg type='s' name='pkg' />"
  "      <arg type='s' name='pkg_version' />"
  "      <arg type='s' name='repo' />"
  "      <arg type='s' name='repo_version' />"
  "    </signal>"
  "    <signal name='AskCorruptedPkg'>"
  "      <arg type='s' name='file' />"
  "      <arg type='s' name='error' />"
  "    </signal>"
  "    <signal name='AskImportKey'>"
  "      <arg type='s' name='key_fingerprint' />"
  "      <arg type='s' name='key_uid' />"
  "      <arg type='s' name='key_created' />"
  "    </signal>"
  "    <signal name='TotalDownload'>"
  "      <arg type='u' name='size' />"
  "    </signal>"
  "    <signal name='Event'>"
  "      <arg type='i' name='type' />"
  "    </signal>"
  "    <signal name='EventInstalled'>"
  "      <arg type='s'  name='pkg' />"
  "      <arg type='s'  name='version' />"
  "      <arg type='as' name='optdeps' />"
  "    </signal>"
  "    <signal name='EventRemoved'>"
  "      <arg type='s'  name='pkg' />"
  "      <arg type='s'  name='version' />"
  "    </signal>"
  "    <signal name='EventUpgraded'>"
  "      <arg type='s'  name='pkg' />"
  "      <arg type='s'  name='old_version' />"
  "      <arg type='s'  name='new_version' />"
  "      <arg type='as' name='newoptdeps' />"
  "    </signal>"
  "    <signal name='EventRetrievingPkgs'>"
  "      <arg type='s' name='repo' />"
  "    </signal>"
  "    <signal name='EventScriptlet'>"
  "      <arg type='s' name='msg' />"
  "    </signal>"
  "    <signal name='EventDeltaGenerating'>"
  "      <arg type='s' name='delta' />"
  "      <arg type='s' name='dest' />"
  "    </signal>"
  "    <signal name='Progress'>"
  "      <arg type='i' name='event' />"
  "      <arg type='s' name='pkg' />"
  "      <arg type='i' name='percent' />"
  "      <arg type='u' name='total' />"
  "      <arg type='u' name='current' />"
  "    </signal>"
  "    <signal name='Debug'>"
  "      <arg type='s' name='msg' />"
  "    </signal>"
  "  </interface>"
  "</node>";

#endif /* _KALU_UPDATER_DBUS_H */
